#pragma once

#include <exception>
#include <ostream>
#include <string>

#include "Bureaucrat.hpp"
class Bureaucrat;

class AForm
{
	private:
		const std::string _name;
		bool _signed;
		int _to_sign;
		int _to_execute;

	protected:
		const std::string _target;
	
	public:
		AForm();
		AForm(const std::string& name, int to_execute, int to_sign, const std::string& target);
		AForm(const AForm& src);
		virtual ~AForm();

		AForm& operator=(const AForm& src);

		const std::string& getName() const;
		bool getSigned() const;
		int getGradeToBeExecute() const;
		int getGradeToBeSign() const;

		void beSigned(const Bureaucrat& bureaucrat);
		virtual void execute(const Bureaucrat& exec) const = 0; 

	class GradeTooHighException: public std::exception
	{
		public:
			const char * what() const throw();
	};
	
	class GradeTooLowException: public std::exception
	{
		public:
			const char * what() const throw();
	};

	class NotSignedException: public std::exception
	{
		public:
			const char * what() const throw();
	};

};

std::ostream& operator<<(std::ostream& os, const AForm& src);
