#include "Intern.hpp"
#include "AForm.hpp"
#include "ShrubberyCreationForm.hpp"
#include "PresidentialPardonForm.hpp"
#include "RobotomyRequestForm.hpp"
#include <string>
#include <iostream>

Intern::Intern()
{
	std::cout << "Intern()" << std::endl;
}

Intern::Intern(Intern const& src)
{
	(void) src;
}

Intern::~Intern()
{
	std::cout << "~Intern()" << std::endl;
}

Intern& Intern::operator=( Intern const& src )
{
	(void) src;
	return *this;
}

AForm* Intern::makeForm( std::string const& formName, std::string const& formTarget) const
{
	static const std::string names[3] = {
		"robotomy request",
		"presidential pardon",
		"shrubbery creation"
	};

	int name_idx;
	for (name_idx = 0; name_idx < 3 && names[name_idx] != formName; ++name_idx) ;

	switch (name_idx) {
		case 0:
			std::cout << "Intern creates " << formName << std::endl;
			return new RobotomyRequestForm(formTarget);
		case 1:
			std::cout << "Intern creates " << formName << std::endl;
			return new PresidentialPardonForm(formTarget);
		case 2:
			std::cout << "Intern creates " << formName << std::endl;
			return new ShrubberyCreationForm(formTarget);
		default:
			std::cout << "Intern can't find form named " << formName << std::endl;
			return NULL;
	}
}

